;#################################################################
; "Let's change any default SystemMenu"
;  by kero (rsdn.ru|rsdn.org)
;  as part of MenuSpy (http://files.rsdn.ru/42164/menuspy.zip)
;#################################################################

; htodw
; DlgProcNULL
; WindowFromPointEx
; GetMenuInfo2
; SetMenuInfo2
; ReInfo
; OnCommand
; OnTimer
; OnInit
; DlgProc

;#################################################################

.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc

inclib kernel32
inclib user32
inclib gdi32
inclib comctl32

MENUINFO STRUCT
  cbSize          DWORD ?
  fMask           DWORD ?
  dwStyle         DWORD ?
  cyMax           DWORD ?
  hbrBack         DWORD ?
  dwContextHelpID DWORD ?
  dwMenuData      DWORD ?
MENUINFO ENDS

MENUBARINFO_ STRUCT
   cbSize         DWORD ?
   rcBar          RECT  <>
   hMenu          DWORD ?
   hwndMenu       DWORD ?
   fBarFocused    WORD  ? ; DWORD
   fFocused       WORD  ? ; DWORD
MENUBARINFO_ ENDS

.const
  ii                   equ      2000
  WM_SYSMENU           equ       313h ; WM_TASKBUTTONMENU
  TPM_SYSMENU          equ       200h
  MNS_CHECKORBMP       equ  04000000h
  MNS_NOTIFYBYPOS      equ  08000000h
  MNS_AUTODISMISS      equ  10000000h
  MNS_DRAGDROP         equ  20000000h
  MNS_MODELESS         equ  40000000h
  MNS_NOCHECK          equ  80000000h
  MIM_APPLYTOSUBMENUS  equ  80000000h
  MIM_STYLE            equ        10h
  MIM_BACKGROUND       equ         2h
  MIM_MAXHEIGHT        equ         1h
  MIM_MENUDATA         equ         8h
  MIM_HELPID           equ         4h
  WHITE_BRUSH          equ         0
  LTGRAY_BRUSH         equ         1
  GRAY_BRUSH           equ         2
  DKGRAY_BRUSH         equ         3
  BLACK_BRUSH          equ         4
  NULL_BRUSH           equ         5
  DC_BRUSH             equ        18
  GA_PARENT            equ         1
  GA_ROOT              equ         2
  GA_ROOTOWNER         equ         3
  OBJID_CLIENT         equ 0FFFFFFFCh       
  OBJID_MENU           equ 0FFFFFFFDh       
  OBJID_SYSMENU        equ 0FFFFFFFFh       

.data
  _lX      db "%8.8lX",0
  _user32  db "user32",0
  _setsm   db "SetSystemMenu",0  ; NT4
  _ga      db "GetAncestor",0    ; NT4 ; 98
  _gmbi    db "GetMenuBarInfo",0 ; NT4 ; 98  
  _gmi     db "GetMenuInfo",0    ; 2k  ; 98
  _smi     db "SetMenuInfo",0    ; 2k  ; 98
  _plus    db "+",0
  _minus   db "-",0

.data?
  hw2   HWND ?
  hw7   HWND ?
  hwx   HWND ?
  hm    HMENU ?
  hmb2  HMENU ?
  hmb7  HMENU ?
  hmbx  HMENU ?
  hmp2  HMENU ?
  hmp7  HMENU ?
  hmpx  HMENU ?
  hmsx  HMENU ?
  hbr   HBRUSH ?

.code

;#################################################################
;
; (From: masm32\m32lib\htodw.asm)
htodw proc uses ebx edi esi String:DWORD
; -----------------------------------
; Convert hex string into dword value
; Return value in eax
; -----------------------------------
    push ebx
    push esi
    push edi
    mov edi, String
    mov esi, String 
     ALIGN 4
  again:  
    mov al,[edi]
    inc edi
    or  al,al
    jnz again
    sub esi,edi
    xor ebx,ebx
    add edi,esi
    xor edx,edx
    not esi             ;esi = lenth
  .while esi != 0
    mov al, [edi]
    cmp al,'A'
    jb figure
    sub al,'a'-10
    adc dl,0
    shl dl,5            ;if cf set we get it bl 20h else - 0
    add al,dl
    jmp next
  figure: 
    sub al,'0'
  next:  
    lea ecx,[esi-1]
    and eax, 0Fh
    shl ecx,2           ;mul ecx by log 16(2)
    shl eax,cl          ;eax * 2^ecx
    add ebx, eax
    inc edi
    dec esi
  .endw
    mov eax,ebx
    pop edi
    pop esi
    pop ebx
    ret
htodw endp

;#################################################################

WindowFromPointEx proc uses ebx edi ptx:DWORD,pty:DWORD,uFlags:DWORD  ; (ptx, pty - screen coord.)

  local pt:POINT

  mov eax,ptx
  mov pt.x,eax
  mov eax,pty
  mov pt.y,eax
  invoke GetDesktopWindow
  mov ebx,eax
  xor ecx,ecx
  .while TRUE
    invoke MapWindowPoints,ecx,ebx,addr pt,1
    invoke ChildWindowFromPointEx,ebx,pt.x,pt.y,uFlags
  .break .if !(eax!=0 && eax!=ebx)
    mov ecx,ebx
    mov ebx,eax
  .endw
  invoke GetMenu,ebx
  mov edi,eax
  invoke GetDlgCtrlID,ebx
  mov edx,eax              ; id
  mov ecx,edi              ; hmenu
  mov eax,ebx              ; hwnd
  ret
WindowFromPointEx endp

; CWP_ALL:
; CWP_SKIPINVISIBLE
; CWP_SKIPDISABLED
; CWP_SKIPTRANSPARENT

;#################################################################

GetMenuInfo2 proc uses ebx edi esi hWnd:HWND,hmenu:HMENU

  local mi:MENUINFO
  local buf[256]:BYTE
  local buf2[256]:BYTE

  invoke RtlZeroMemory,addr mi,sizeof mi
  mov mi.cbSize,sizeof mi

  push MIM_STYLE
  push MIM_BACKGROUND
  push MIM_HELPID  
  push MIM_MENUDATA  
  push MIM_MAXHEIGHT  
  push MIM_APPLYTOSUBMENUS  
  xor ebx,ebx
  mov edi,ii+10
  .while edi<=ii+15
    pop esi
    invoke IsDlgButtonChecked,hWnd,edi
    test eax,eax
    jz @f
    or ebx,esi
@@:
    inc edi
  .endw
  mov mi.fMask,ebx

;  invoke GetMenuInfo,hmenu,addr mi
  invoke GetModuleHandle,offset _user32
  invoke GetProcAddress,eax,offset _gmi
  .if eax==0
    ret
  .else
    lea edx,mi
    push edx
    push hmenu
    call eax
  .endif

  mov eax,mi.dwStyle
  push eax
  mov eax,mi.hbrBack
  push eax
  mov eax,mi.dwContextHelpID
  push eax
  mov eax,mi.dwMenuData
  push eax
  mov eax,mi.cyMax
  push eax
  mov eax,mi.fMask
  push eax
  mov edi,ii+20
  .while edi<=ii+25
    pop eax
    invoke wsprintf,addr buf,offset _lX,eax
    invoke GetDlgItemText,hWnd,edi,addr buf2,256
    invoke lstrcmpi,addr buf,addr buf2
    .if eax!=0
      invoke SetDlgItemText,hWnd,edi,addr buf
    .endif
    inc edi
  .endw

  mov esi,mi.dwStyle
  push MNS_NOCHECK
  push MNS_MODELESS
  push MNS_DRAGDROP
  push MNS_AUTODISMISS
  push MNS_NOTIFYBYPOS
  push MNS_CHECKORBMP
  mov edi,ii+30
  .while edi<=ii+35
    invoke IsDlgButtonChecked,hWnd,edi
    pop edx
    and edx,esi
    .if eax==0 && edx!=0
      mov eax,BST_CHECKED
      jmp @f
    .elseif eax!=0 && edx==0
      mov eax,BST_UNCHECKED
@@:
      invoke CheckDlgButton,hWnd,edi,eax
    .endif
    inc edi
  .endw

  mov edx,mi.hbrBack
  mov eax,hmenu
  ret
GetMenuInfo2 endp

;#################################################################

SetMenuInfo2 proc uses ebx edi esi hWnd:HWND,hmenu:HMENU

  local mi:MENUINFO
  local buf[256]:BYTE

  invoke RtlZeroMemory,addr mi,sizeof mi
  mov mi.cbSize,sizeof mi

  push MIM_STYLE
  push MIM_BACKGROUND
  push MIM_HELPID  
  push MIM_MENUDATA  
  push MIM_MAXHEIGHT  
  push MIM_APPLYTOSUBMENUS  
  xor ebx,ebx
  mov edi,ii+10
  .while edi<=ii+15
    pop esi
    invoke IsDlgButtonChecked,hWnd,edi
    test eax,eax
    jz @f
    or ebx,esi
@@:
    inc edi
  .endw
  mov mi.fMask,ebx

  push MNS_NOCHECK
  push MNS_MODELESS
  push MNS_DRAGDROP
  push MNS_AUTODISMISS
  push MNS_NOTIFYBYPOS
  push MNS_CHECKORBMP
  xor ebx,ebx
  mov edi,ii+30 
  .while edi<=ii+35
    pop esi
    invoke IsDlgButtonChecked,hWnd,edi
    test eax,eax
    jz @f
    or ebx,esi
@@:
    inc edi
  .endw
  mov mi.dwStyle,ebx

  invoke GetDlgItemText,hWnd,ii+23,addr buf,256
  invoke htodw,addr buf
  mov mi.dwContextHelpID,eax

  invoke GetDlgItemText,hWnd,ii+22,addr buf,256
  invoke htodw,addr buf
  mov mi.dwMenuData,eax

  invoke GetDlgItemText,hWnd,ii+21,addr buf,256
  invoke htodw,addr buf
  mov mi.cyMax,eax

  invoke GetDlgItemText,hWnd,ii+24,addr buf,256
  invoke htodw,addr buf
  mov mi.hbrBack,eax

  invoke IsDlgButtonChecked,hWnd,ii+72
  .if eax==BST_UNCHECKED
;    invoke SetMenuInfo,hmenu,addr mi  ; (unworkable for default sysmenu)
    invoke GetModuleHandle,offset _user32
    invoke GetProcAddress,eax,offset _smi
    .if eax==0
      ret
    .else
      lea edx,mi
      push edx
      push hmenu
      call eax
    .endif
  .else    
    invoke CreateMenu
    mov esi,eax
    invoke InsertMenu,esi,0,MF_BYPOSITION or MF_POPUP,hmenu,0
;    invoke SetMenuInfo,esi,addr mi
    invoke GetModuleHandle,offset _user32
    invoke GetProcAddress,eax,offset _smi
    .if eax==0
      ret
    .else
      lea edx,mi
      push edx
      push esi
      call eax
    .endif
    invoke RemoveMenu,esi,0,MF_BYPOSITION
    invoke DestroyMenu,esi
  .endif
  mov eax,hmenu
  ret
SetMenuInfo2 endp

;#################################################################

ReInfo proc uses ebx edi esi hWnd:HWND,hW:HWND,iD:DWORD  ; ii+51, ii+53, ii+55

  local mbi:MENUBARINFO_
  local buf[256]:BYTE
  local buf2[256]:BYTE
  local num:DWORD

  mov eax,iD
  mov num,eax

  invoke RtlZeroMemory,addr mbi,sizeof mbi
  mov mbi.cbSize,sizeof mbi
;  invoke GetMenuBarInfo,hW,OBJID_SYSMENU,0,addr mbi
  invoke GetModuleHandle,offset _user32
  invoke GetProcAddress,eax,offset _gmbi
  .if eax==0
    ret
  .else
    lea edx,mbi
    push edx
    push 0
    push OBJID_SYSMENU
    push hW
    call eax
  .endif

  mov edi,mbi.hMenu       ; sysbar
  invoke GetSubMenu,edi,0 ; instead of GetSystemMenu(hWnd,FALSE)
  mov esi,eax             ; syspop

  invoke GetMenuItemCount,edi
  mov ebx,eax
  invoke GetDlgItemInt,hWnd,num,0,1
  .if eax!=ebx
    invoke SetDlgItemInt,hWnd,num,ebx,1
  .endif

  invoke GetMenuItemCount,esi
  mov ebx,eax
  dec num
  invoke GetDlgItemInt,hWnd,num,0,1
  .if eax!=ebx
    invoke SetDlgItemInt,hWnd,num,ebx,1
  .endif

  invoke wsprintf,addr buf,offset _lX,esi
  add num,10
  invoke GetDlgItemText,hWnd,num,addr buf2,256
  invoke lstrcmpi,addr buf2,addr buf
  .if eax!=0
    invoke SetDlgItemText,hWnd,num,addr buf
  .endif

  invoke wsprintf,addr buf,offset _lX,edi
  inc num
  invoke GetDlgItemText,hWnd,num,addr buf2,256
  invoke lstrcmpi,addr buf2,addr buf
  .if eax!=0
    invoke SetDlgItemText,hWnd,num,addr buf
  .endif

  mov eax,edi ; bar
  mov ecx,esi ; pop
  mov edx,ebx ; num
  ret
ReInfo endp 

;#################################################################

OnCommand proc uses ebx edi esi hWnd:HWND,wParam:WPARAM,lParam:LPARAM

  local pt:POINT
  local buf[256]:BYTE
  local buf2[256]:BYTE

  mov ebx,wParam

  .if ebx==ii+75
    invoke IsDlgButtonChecked,hWnd,ii+75
    .if eax==BST_CHECKED
      invoke SetTimer,hWnd,ii,100,0
    .else
      invoke KillTimer,hWnd,ii
      mov eax,hWnd
      mov hwx,eax
      invoke ReInfo,hWnd,hwx,ii+55
      mov hmbx,eax
      mov hmpx,ecx
    .endif    

  .elseif ebx==ii+78
    invoke IsDlgButtonChecked,hWnd,ii+76
    mov edx,hWnd
    .if eax==BST_CHECKED || edx==hwx
      invoke GetSystemMenu,hwx,0
      mov hmsx,eax
      invoke ReInfo,hWnd,hwx,ii+55
      mov hmbx,eax
      mov hmpx,ecx
    .else
      invoke Beep,300,300
    .endif

  .elseif ebx==ii+77
    invoke IsDlgButtonChecked,hWnd,ii+76
    mov edx,hWnd
    .if eax==BST_CHECKED || edx==hwx
      invoke GetWindowLong,hwx,GWL_STYLE
      xor eax,WS_SYSMENU
      invoke SetWindowLong,hwx,GWL_STYLE,eax
      invoke SetWindowPos,hwx,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
      invoke GetWindowLong,hwx,GWL_STYLE
      and eax,WS_SYSMENU
      .if eax==0
        mov eax,offset _minus
      .else
        mov eax,offset _plus
      .endif
      invoke SetDlgItemText,hWnd,ii+77,eax
      invoke ReInfo,hWnd,hwx,ii+55
      mov hmbx,eax
      mov hmpx,ecx
    .else
      invoke Beep,300,300
    .endif

  .elseif ebx==ii+74  ; 2/7
    invoke IsDlgButtonChecked,hWnd,ii+76
    mov edx,hWnd
    .if eax==BST_CHECKED || edx==hwx
      invoke ReInfo,hWnd,hwx,ii+55
      mov hmbx,eax
      mov hmpx,ecx
      .if edx!=2
        invoke GetSystemMenu,hwx,FALSE
        mov hmsx,eax
        invoke GetModuleHandle,offset _user32
        invoke GetProcAddress,eax,offset _setsm
        .if eax!=0
          push hmb2
          push hwx
          call eax
          jmp @f
        .else
          invoke Beep,300,300
        .endif
      .else
        invoke GetSystemMenu,hwx,FALSE
        mov hmsx,eax
        invoke GetSystemMenu,hwx,TRUE
@@:
        invoke SetForegroundWindow,hwx
        invoke PostMessage,hwx,WM_SYSCOMMAND,SC_KEYMENU,VK_SPACE
      .endif
      invoke ReInfo,hWnd,hwx,ii+55
      mov hmbx,eax
      mov hmpx,ecx
    .else
      invoke Beep,300,300
    .endif

  .elseif ebx==ii+73  ; =
    invoke IsDlgButtonChecked,hWnd,ii+76
    mov edx,hWnd
    .if eax==BST_CHECKED || edx==hwx
      invoke SetMenuInfo2,hWnd,hm
      jmp @b
    .else
      invoke Beep,300,300
    .endif

  .elseif ebx>=ii+30 && ebx<=ii+35  ; dwStyle
    push MNS_NOCHECK
    push MNS_MODELESS
    push MNS_DRAGDROP
    push MNS_AUTODISMISS
    push MNS_NOTIFYBYPOS
    push MNS_CHECKORBMP
      xor ebx,ebx
      mov edi,ii+30  
      .while edi<=ii+35
        pop esi
        invoke IsDlgButtonChecked,hWnd,edi
        test eax,eax
        jz @f
        or ebx,esi
@@:
        inc edi
      .endw
      invoke wsprintf,addr buf,offset _lX,ebx
      invoke SetDlgItemText,hWnd,ii+25,addr buf

  .elseif ebx==ii+65
    mov eax,hmbx
    jmp @f
  .elseif ebx==ii+64
    mov eax,hmpx
    jmp @f
  .elseif ebx==ii+61
    mov eax,hmb2
    jmp @f
  .elseif ebx==ii+60
    mov eax,hmp2
    jmp @f
  .elseif ebx==ii+63
    mov eax,hmb7
    jmp @f
  .elseif ebx==ii+62
    mov eax,hmp7
@@:
    mov hm,eax
    invoke GetMenuInfo2,hWnd,hm
    mov hbr,edx
    invoke GetDlgItem,hWnd,ii+24
    invoke InvalidateRect,eax,0,1

  .elseif  ebx>=ii+10 && ebx<=ii+15
    invoke GetMenuInfo2,hWnd,hm
    mov hbr,edx
    invoke GetDlgItem,hWnd,ii+24
    invoke InvalidateRect,eax,0,1

  .elseif ebx==ii+46
    xor eax,eax
    jmp @f

  .elseif ebx>=ii+40 && ebx<=ii+45
    mov eax,ebx
    sub eax,ii+40
    invoke GetStockObject,eax
@@:
    mov hbr,eax
    invoke wsprintf,addr buf,offset _lX,eax
    invoke SetDlgItemText,hWnd,ii+24,addr buf

  .elseif ebx==ii+24
    invoke SendDlgItemMessage,hWnd,ii+24,WM_GETTEXT,256,addr buf
    invoke SendDlgItemMessage,hWnd,ii+124,WM_SETTEXT,0,addr buf
    invoke GetDlgItem,hWnd,ii+24
    invoke ShowWindow,eax,SW_HIDE
    invoke GetDlgItem,hWnd,ii+124
    invoke ShowWindow,eax,SW_SHOWNORMAL

  .elseif ebx==ii+224
    invoke SendDlgItemMessage,hWnd,ii+124,WM_GETTEXT,256,addr buf
    invoke SendDlgItemMessage,hWnd,ii+24,WM_SETTEXT,0,addr buf
    invoke htodw,addr buf
    mov hbr,eax
    invoke GetDlgItem,hWnd,ii+124
    invoke ShowWindow,eax,SW_HIDE
    invoke GetDlgItem,hWnd,ii+24
    invoke ShowWindow,eax,SW_SHOWNORMAL

  .elseif ebx==ii+80
    invoke DestroyMenu,hmpx
    invoke ReInfo,hWnd,hwx,ii+55
    mov hmbx,eax
    mov hmpx,ecx

  .elseif ebx==ii+81
    invoke DestroyMenu,hmbx
    invoke ReInfo,hWnd,hwx,ii+55
    mov hmbx,eax
    mov hmpx,ecx

  .endif
  ret
OnCommand endp

;#################################################################

DlgProcNULL proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  xor eax,eax
  ret
DlgProcNULL endp

;#################################################################

OnTimer proc uses ebx edi esi hWnd:HWND

  local pt:POINT
  local buf[256]:BYTE
  local buf2[256]:BYTE

  invoke IsDlgButtonChecked,hWnd,ii+76
  .if eax==BST_CHECKED
    ret
  .endif

  invoke GetCursorPos,addr pt
  invoke WindowFromPointEx,pt.x,pt.y,CWP_SKIPINVISIBLE
  mov ebx,eax
  mov hwx,eax
  mov edi,edx
  mov esi,ecx

  invoke GetModuleHandle,offset _user32
  invoke GetProcAddress,eax,offset _ga
  .if eax!=0
    push GA_ROOT
    push ebx
    call eax
    .if eax!=ebx
      jmp @1
    .else
      jmp @2
    .endif    
  .else
    .if esi==edi ; && esi!=0
@1:
      invoke GetDlgItemInt,hWnd,ii+71,0,1
      .if eax!=edi
        invoke SetDlgItemInt,hWnd,ii+71,edi,1
      .endif
    .else
@2:
      invoke GetDlgItemText,hWnd,ii+71,addr buf2,256
      .if eax!=0
        invoke SetDlgItemText,hWnd,ii+71,0
      .endif
    .endif
  .endif

  invoke GetWindowLong,ebx,GWL_STYLE
  and eax,WS_SYSMENU
  .if eax==0
    mov esi,offset _minus
  .else
    mov esi,offset _plus
  .endif
  invoke GetDlgItemText,hWnd,ii+77,addr buf,256
  invoke lstrcmpi,addr buf,esi
  .if eax!=0
    invoke SetDlgItemText,hWnd,ii+77,esi
  .endif

  invoke ReInfo,hWnd,hwx,ii+55
  mov hmbx,eax
  mov hmpx,ecx

  invoke GetKeyState,VK_F8
  and eax,8000h
  mov ebx,eax
  invoke GetAsyncKeyState,VK_F8
  and eax,8000h
  .if eax!=0 || ebx!=0
    invoke CheckDlgButton,hWnd,ii+76,BST_CHECKED
  .endif

  ret
OnTimer endp

;#################################################################

OnInit proc uses ebx edi esi hWnd:HWND

  local pt:POINT
  local buf[256]:BYTE
  local buf2[256]:BYTE

  invoke GetModuleHandle,0
  mov ebx,eax
  invoke LoadIcon,ebx,1
  invoke SetClassLong,hWnd,GCL_HICON,eax
  
  invoke GetWindowLong,hWnd,GWL_STYLE
  or eax,WS_THICKFRAME or WS_MINIMIZEBOX or WS_MAXIMIZEBOX
  invoke SetWindowLong,hWnd,GWL_STYLE,eax
  invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED

  mov eax,hWnd
  mov hwx,eax  

  invoke CreateDialogParam,ebx,ii+2,0,offset DlgProcNULL,0
  mov hw2,eax
  invoke CreateDialogParam,ebx,ii+7,0,offset DlgProcNULL,0
  mov hw7,eax

  invoke GetWindowLong,hw7,GWL_STYLE
  or eax,WS_SYSMENU
  invoke SetWindowLong,hw7,GWL_STYLE,eax
  invoke SetWindowPos,hw7,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED

  invoke ReInfo,hWnd,hw2,ii+51
  mov hmb2,eax
  mov hmp2,ecx

  invoke ReInfo,hWnd,hw7,ii+53
  mov hmb7,eax
  mov hmp7,ecx

  mov edi,ii+10
  .while edi<=ii+15
    invoke CheckDlgButton,hWnd,edi,BST_CHECKED
    inc edi
  .endw

  invoke CheckDlgButton,hWnd,ii+72,BST_CHECKED

  invoke SendDlgItemMessage,hWnd,ii+60,BM_CLICK,0,0
  ret
OnInit endp

;#################################################################

DlgProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local pt:POINT
  local rt:RECT
  local ps:PAINTSTRUCT
  local buf[256]:BYTE

  .if uMsg==WM_CLOSE
    invoke KillTimer,hWnd,ii
    invoke EndDialog,hWnd,0

  .elseif uMsg==WM_TIMER
    invoke OnTimer,hWnd

  .elseif uMsg==WM_INITDIALOG
    invoke OnInit,hWnd

  .elseif uMsg==WM_COMMAND
    invoke OnCommand,hWnd,wParam,lParam

  .elseif uMsg==WM_NCLBUTTONUP && wParam==HTMINBUTTON
    invoke ShowWindow,hWnd,SW_MINIMIZE

  .elseif uMsg==WM_LBUTTONDOWN
    invoke PostMessage,hWnd,WM_SYSCOMMAND,SC_SIZE+9,0

  .elseif uMsg==WM_SIZE
    mov edi,lParam
    mov esi,edi
    and edi,0FFFFh ; width
    shr esi,16     ; height
    push 0
    push ii+70
    .while TRUE
      pop eax
    .break .if eax==0
      invoke GetDlgItem,hWnd,eax
      mov ebx,eax
      invoke GetWindowRect,ebx,addr rt
      invoke MapWindowPoints,0,hWnd,addr rt,2
      mov edx,edi
      sub edx,rt.left
      mov ecx,rt.bottom
      sub ecx,rt.top
      invoke SetWindowPos,ebx,0,0,0,edx,ecx,SWP_NOZORDER or SWP_NOMOVE or SWP_FRAMECHANGED
    .endw
    invoke InvalidateRect,hWnd,0,1

  .elseif uMsg==WM_PAINT
    invoke BeginPaint,hWnd,addr ps
    mov ebx,eax
    invoke GetDlgItem,hWnd,ii+72
    mov edx,eax
    invoke GetWindowRect,edx,addr rt
    invoke MapWindowPoints,0,hWnd,addr rt,2
    mov edi,rt.left
    mov esi,rt.top
    sub edi,4
    sub esi,2
    invoke GetDlgItem,hWnd,ii+10
    mov edx,eax
    invoke GetWindowRect,edx,addr rt
    invoke MapWindowPoints,0,hWnd,addr rt,2
    mov rt.left,edi
    mov rt.top,esi
    add rt.right,1
    add rt.bottom,1
    invoke GetStockObject,GRAY_BRUSH
    invoke FrameRect,ebx,addr rt,eax
    invoke EndPaint,hWnd,addr ps

  .elseif uMsg==WM_CTLCOLORSTATIC
    invoke SetBkMode,wParam,TRANSPARENT
    invoke GetDlgCtrlID,lParam
    .if eax==ii+40
      mov eax,WHITE_BRUSH
      jmp @f
    .elseif eax==ii+41
      mov eax,LTGRAY_BRUSH
      jmp @f
    .elseif eax==ii+42
      invoke SetTextColor,wParam,White
      mov eax,GRAY_BRUSH
      jmp @f
    .elseif eax==ii+43
      invoke SetTextColor,wParam,White
      mov eax,DKGRAY_BRUSH
      jmp @f
    .elseif eax==ii+44
      invoke SetTextColor,wParam,White
      mov eax,BLACK_BRUSH
      jmp @f      
    .elseif eax==ii+45
      mov eax,NULL_BRUSH
@@:
      invoke GetStockObject,eax
    .elseif eax==ii+24
      invoke SetBkMode,wParam,OPAQUE
      mov eax,hbr
    .else
      xor eax,eax
    .endif
    ret

  .elseif uMsg==WM_CTLCOLOREDIT
    invoke GetDlgCtrlID,lParam
    .if eax==ii+124
      invoke SetBkMode,wParam,OPAQUE
      mov eax,hbr
    .else
      xor eax,eax
    .endif
    ret

  .elseif uMsg==WM_CONTEXTMENU
    mov edi,lParam
    mov esi,edi
    and edi,0ffffh
    shr esi,16
    invoke WindowFromPointEx,edi,esi,CWP_SKIPINVISIBLE
    mov eax,edx
    .if eax==ii+73
      invoke IsDlgButtonChecked,hWnd,ii+76
      mov edx,hWnd
      .if eax==BST_CHECKED || edx==hwx
        invoke SetForegroundWindow,hwx    
        invoke PostMessage,hwx,WM_SYSMENU,0,-1
      .else
        invoke Beep,300,300
      .endif
    .elseif eax==ii+78
      invoke IsDlgButtonChecked,hWnd,ii+76
      mov edx,hWnd
      .if eax==BST_CHECKED || edx==hwx
        invoke GetSystemMenu,hwx,1
        invoke ReInfo,hWnd,hwx,ii+55
        mov hmbx,eax
        mov hmpx,ecx
      .else
        invoke Beep,300,300
      .endif
    .elseif eax==ii+60 || eax==ii+50
      mov ebx,hw2
      jmp @f
    .elseif eax==ii+62 || eax==ii+52
      mov ebx,hw7
      jmp @f
    .elseif eax==ii+64 || eax==ii+54
      mov ebx,hwx
@@:
      invoke SetForegroundWindow,ebx
      invoke PostMessage,ebx,WM_SYSMENU,0,lParam
    .elseif eax==ii+61 || eax==ii+51
      mov ebx,hmb2
      jmp @f
    .elseif eax==ii+63 || eax==ii+53
      mov ebx,hmb7
      jmp @f
    .elseif eax==ii+65 || eax==ii+55
      mov ebx,hmbx
      jmp @f
    .elseif eax==ii+82
      mov ebx,hmsx
@@:
      invoke IsDlgButtonChecked,hWnd,ii+82
      .if eax==BST_CHECKED
        mov eax,TPM_SYSMENU
      .else
        xor eax,eax
      .endif
      invoke TrackPopupMenuEx,ebx,eax,edi,esi,hWnd,0 ;(TPM_SYSMENU = unworkable after Win9x)
    .else
      xor eax,eax
      ret
    .endif

  .elseif uMsg==WM_SETCURSOR
    invoke IsDlgButtonChecked,hWnd,ii+76
    .if eax==BST_CHECKED
      xor eax,eax
      ret
    .endif
    invoke GetDlgItemText,hWnd,ii+71,addr buf,256
    invoke GetCursorPos,addr pt
    invoke WindowFromPointEx,pt.x,pt.y,CWP_SKIPINVISIBLE
    mov edi,edx
    .if eax==hWnd || eax==0
      invoke SetDlgItemText,hWnd,ii+71,0
      xor eax,eax
    .else
      invoke SetDlgItemInt,hWnd,ii+71,edi,1
      invoke GetModuleHandle,0
      mov edx,eax
      invoke LoadString,edx,edi,addr buf,256
      .if eax!=0
        lea eax,buf
      .endif
    .endif
    invoke SetDlgItemText,hWnd,ii+70,eax
    xor eax,eax
    ret

  .else
    xor eax,eax
    ret
  .endif

  xor eax,eax
  inc eax
  ret
DlgProc endp

;#################################################################

start:
  invoke GetModuleHandle,0
  invoke DialogBoxParam,eax,ii,0,offset DlgProc,0
  invoke ExitProcess,0
  invoke InitCommonControls
end start

;#################################################################
